use SWF::Chart;
use Mail::IMAPClient;
use strict;

use constant HOST => '...';
use constant USERNAME => '...';
use constant PASSWORD => '...';

my $imap = Mail::IMAPClient->new(
        Server  => HOST,
        User    => USERNAME,
        Password=> PASSWORD,
)
        or die "Verbindungsaufbau mit ".HOST." nicht mglich: $@";

my $chartdata = {
        chart_type => '3d pie',
        chart_data => [
                [''],
                ['']
        ]
};

foreach my $foldername ($imap->folders) {
        my $number_of_messages = $imap->message_count( $foldername );
        push @{$chartdata->{ chart_data }->[0]}, $foldername;
        push @{$chartdata->{ chart_data }->[1]}, $number_of_messages;
}

DrawChart($chartdata);

$chartdata = {
        chart_type => '3d column',
        chart_data => [
                ['','<100','<1K','<10K','<100K','<1M','<10M'],
                ['Dateigroesse']
        ]
};


my $last_message_count = 0;
for (my $number_of_bytes=100;$number_of_bytes<100000000;$number_of_bytes*=10) {
        my $message_count = 0;
        foreach my $foldername ($imap->folders) {
                $imap->select($foldername);
                my @ids = $imap->search("SMALLER ".$number_of_bytes);
                $message_count += @ids;
        }
        push @{$chartdata->{ chart_data }->[1]}, $message_count - $last_message_count;
        print $number_of_bytes, "=>", $message_count - $last_message_count,"\n";
        $last_message_count = $message_count;
}

DrawChart( $chartdata );
