use Mail::IMAPClient;
use strict;

use constant HOST => 'abc.def.gh';
use constant USERNAME => 'user';
use constant PASSWORD => 'geheim';

my $imap = Mail::IMAPClient->new(
                Server  => HOST,
                User    => USERNAME,
                Password=> PASSWORD,
)
        or die "Verbindungsaufbau mit ".HOST." nicht mglich: $@";


$imap->select("INBOX".$imap->separator()."failed");

my $count = $imap->message_count;

foreach my $m (1..$count) {
  my $b = $imap->body_string($m);
  my ($to) = grep /^To:.*$/, split (/\r\n/,$b);
  $to =~ s/^To: //;
  if ($to =~ /=\?ISO/i) {
    $to =~ s/=([A-F0-9][A-F0-9])/chr(hex($1))/eg;
    $to =~ s/_/ /g;
    $to =~ s/=\?ISO-8859-1\?Q\?//gi;
    $to =~ s/\?=//g;
  }
  print "$to\n";
}

